/*
 * This is the header file for the capability layer
 * of Efficient Capability-Based Messaging system
 *
 * It defines some data types and the function prototypes
 * nedded to manage capabilities
 */

#ifndef _ECBM_CAP_H_
#define _ECBM_CAP_H_

#include <linux/linkage.h> /* For asmlinkage */

#include <linux/ecbm/cap_types.h>

/* 
 * System call prototypes
 */
asmlinkage int ecbm_release_area(void* buffer);

/* 
 * Functions to manage capabilities 
 */
capability* ecbm_create_capability(void* buffer, int size, prot_t rights);
void* ecbm_acquire_capability(capability* cap, prot_t rights);
void ecbm_insert_capability(struct capability_table* caps);
int ecbm_release_capability(capability* cap);
capability* ecbm_unlink_capability(logical_address_t logical);

#endif
