/*
 * This is the header file for the communication layer
 * of Efficient Capability-Based Messaging system
 *
 * It defines some data types and the function prototypes
 * nedded to manage communication channels
 */

#ifndef _ECBM_COMM_H_
#define _ECBM_COMM_H_

#include <linux/linkage.h> /* For asmlinkage */

#include <linux/ecbm/cap_types.h>
#include <linux/ecbm/comm_types.h>

/* 
 * System call prototypes
 */
asmlinkage magic_number_t ecbm_get_magic_number(void);
asmlinkage id_t ecbm_install_channel(magic_number_t magic, int asynchrony);
asmlinkage id_t ecbm_acquire_channel(magic_number_t magic);

asmlinkage int ecbm_zc_send(id_t id, void* buffer, int size, prot_t rights);
asmlinkage void* ecbm_zc_receive(id_t id, prot_t rights);

asmlinkage int ecbm_oc_send(id_t id, void* buffer, int size);
asmlinkage void* ecbm_oc_receive(id_t id);

/*
 * Function needed to implement the previous
 */
channel* ecbm_search_channel(magic_number_t magic);
void ecbm_insert_channel(channel* ch);
void ecbm_avl_insert(channel* ch);
void ecbm_avl_build(void);
void ecbm_avl_update(channel* ch);
channel* ecbm_avl_rebalance(channel* ch);

#endif












