/*
 * This is the header for the user-space library layer 
 * of Efficient Capability-Based Messaging system
 *
 * All function prototypes defined in here
 * are wrappers for corresponding system calls
 */

#ifndef _ECBM_H_
#define _ECBM_H_

#include <linux/unistd.h> /* For errno */

#include <linux/ecbm/cap_types.h>
#include <linux/ecbm/comm_types.h>

/* 
 * Functions to install and acquire 
 * a new communication channel
 * and to transfer messages among different 
 * process's logical address spaces
 */
static inline _syscall0(id_t,get_magic_number)
static inline _syscall2(id_t,install,magic_number_t,magic,int,asynchrony)
static inline _syscall1(id_t,acquire,magic_number_t,magic)

static inline _syscall4(int,zc_send,id_t,id,void*,buffer,int,size,prot_t,rights)
static inline _syscall2(void*,zc_receive,id_t,id,prot_t,rights)
static inline _syscall1(int,release,void*,buffer)

static inline _syscall3(int,oc_send,id_t,id,void*,buffer,int,size)
static inline _syscall1(void*,oc_receive,id_t,id)

#endif
