/*
 * This is the type header for the capability layer 
 * of Efficient Capability-Based Messaging system
 *
 * All types used in the implementation 
 * are defined in here
 */

#ifndef _ECBM_CAP_TYPES_H_
#define _ECBM_CAP_TYPES_H_

/* Some data types */
#define physical_address_t unsigned long
#define logical_address_t unsigned long
#define prot_t unsigned long

#ifdef __KERNEL__

#define TRUE 1
#define FALSE 0

/* The capability struct */
typedef struct
{
 unsigned long offset_start;
 physical_address_t* addresses;
 int size;
 prot_t rights;
} capability;

#endif

#endif

