/*
 * This is the type header for the communication layer 
 * of Efficient Capability-Based Messaging system
 *
 * All types used in the implementation 
 * are defined in here
 */

#ifndef _ECBM_COMM_TYPES_H_
#define _ECBM_COMM_TYPES_H_

#include <linux/ecbm/cap_types.h>

/* Some data types */
#define magic_number_t unsigned long
#define id_t unsigned long

#ifdef __KERNEL__

/* Max number of channels allowed in the ordered list */
#define ECBM_COMM_RES_MAX 32

/* Max number opf channels allowed per process */
#define ECBM_COMM_PP_MAX 32

/* No ready channel */
#define ECBM_NO_READY 0

/* The channel struct */
typedef struct ch
{
 magic_number_t magic;
 struct ch* next;
 struct ch* left;
 struct ch* right;
 struct ch* parent;
 int balance;
 struct wait_queue* acquire;

 spinlock_t spin;
 
 int n;
 int filled;
 int insert;
 int extract;
 capability** cap;
 struct wait_queue* full;
 struct wait_queue* empty;
} channel;

#endif

#endif



